/// Data structures for describing geometry with vertex data and index data.
library index_geometry;

import 'dart:collection';
import 'dart:typed_data';

import 'package:quiver/collection.dart';

import 'vertex.dart';
import 'vertex_data.dart';
import 'geometry_primitives.dart';

part 'src/index_geometry/index_geometry.dart';
part 'src/index_geometry/index_list.dart';
part 'src/index_geometry/line_loop.dart';
part 'src/index_geometry/line_strip.dart';
part 'src/index_geometry/lines.dart';
part 'src/index_geometry/points.dart';
part 'src/index_geometry/triangle_fan.dart';
part 'src/index_geometry/triangle_strip.dart';
part 'src/index_geometry/triangles.dart';
part 'src/index_geometry/topology.dart';
